compile 1.7 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667
  1. #!/bin/bash
  2. set -eo pipefail
  3. SUCCESS_TXT="${GREEN}[SUCCESS]${NC}"
  4. src_file=$1
  5. exe_file=$(basename "${src_file%.*}")
  6. if [[ -z "$MACHINE" ]]; then
  7. echo "Must provide MACHINE for compile"
  8. exit 1
  9. fi
  10. if [[ "$MACHINE" == "Windows" ]]; then
  11. exe_file=$(basename "${src_file%.*}".exe)
  12. fi
  13. if [[ -z "$src_file" ]]; then
  14. echo "Must provide \$1 for compile"
  15. exit 1
  16. fi
  17. if [[ -z "$CPP_INCLUDE_DIR" ]]; then
  18. echo "Must provide CPP_INCLUDE_DIR in environment"
  19. exit 1
  20. fi
  21. if [[ -z "$CPP" ]]; then
  22. echo "Must provide CPP in environment"
  23. exit 1
  24. fi
  25. rm -f "$exe_file"
  26. EXTRA_ARGS=""
  27. if [[ -z "${TESTLIB_COMPILER_OPTIMIZATION_OPT}" ]]; then
  28. OPTIMIZATION="2"
  29. else
  30. OPTIMIZATION="${TESTLIB_COMPILER_OPTIMIZATION_OPT}"
  31. fi
  32. if [[ "$CPP" == "cl.exe" ]]; then
  33. echo "Compiling $src_file, running:" "$CPP" "$CPP_STANDARD" "-F268435456" "-EHsc" "-O${OPTIMIZATION}" -I"${CPP_INCLUDE_DIR}" -Fe"$exe_file" "$src_file"
  34. "$CPP" "$CPP_STANDARD" "-F268435456" "-EHsc" "-O${OPTIMIZATION}" -I"${CPP_INCLUDE_DIR}" -Fe"$exe_file" "$src_file"
  35. else
  36. "$CPP" --version
  37. dir=$(dirname "$CPP")
  38. if [[ "$dir" == *"/bin" ]] || [[ "$MACHINE" == "Windows" ]]; then
  39. EXTRA_ARGS="${EXTRA_ARGS} -static"
  40. fi
  41. echo "Compiling $src_file, running:" "$CPP" "$CPP_OPTS" "$CPP_STANDARD" -Wpedantic -Werror -I"${CPP_INCLUDE_DIR}""$EXTRA_ARGS" -o"$exe_file" "-O${OPTIMIZATION}" "$src_file"
  42. eval "$CPP" "$CPP_OPTS" "$CPP_STANDARD" -Wpedantic -Werror -I"${CPP_INCLUDE_DIR}""$EXTRA_ARGS" -o"$exe_file" "-O${OPTIMIZATION}" "$src_file"
  43. fi
  44. rm -f ./*.o ./*.obj
  45. if [ ! -f "$exe_file" ]; then
  46. echo "Compilation failed: file $exe_file not found"
  47. exit 1
  48. fi
  49. echo -e "${SUCCESS_TXT} $src_file compiled\n"
  50. if [[ "$2" == "--check-only" ]]; then
  51. rm -rf "$exe_file"
  52. fi